PHP异常处理机制

更新日期: 2019-02-19阅读: 1821标签: 异常

1、异常概述

异常(Exception)是一种错误处理机制,用于在指定的错误发生时改变脚本的正常流程。

当异常被触发时,当前代码状态被保存,代码执行被切换到预定义的异常处理器函数(如果有)

根据情况,处理器也许会从保存的代码状态重新开始执行代码,终止脚本执行,或从代码中另外的位置继续执行脚本


2、异常的基本使用

当异常被抛出时,其后的代码不会继续执行,php 会尝试查找匹配的 "catch" 代码块。

如果异常没有被捕获,而且又没用使用 set_exception_handler() 作相应的处理的话,那么将发生一个严重的错误(致命错误),并且输出 "Uncaught Exception" (未捕获异常)的错误消息。

尝试抛出一个异常,同时不去捕获它

//create function with an exception
function checkNum($number){
    if($number>1){
        throw new Exception("Value must be 1 or below");
    }
}
//trigger exception
checkNum(2);

上面的代码会获得类似这样的一个错误:

Fatal error: Uncaught exception ‘Exception‘ with message ‘Value must be 1 or below‘ in C:\webfolder\test.php:6

Stack trace: #0 C:\webfolder\test.php(12):checkNum(28) #1 {main} thrown in C:\webfolder\test.php on line 6

注意:PHP默认是警告模式,如果需要对系统错误使用异常处理机制,则要在处理代码之前设置错误处理模式

set_error_handler(function(){
    throw new Exception(‘错误!‘);
});


3、Try, throw 和 catch

正确的处理程序应当包括:

Try - 使用异常的函数应该位于 "try" 代码块内。如果没有触发异常,则代码将照常继续执行。但是如果异常被触发,会抛出一个异常。

Throw - 这里规定如何触发异常。每一个 "throw" 必须对应至少一个 "catch"

Catch - "catch" 代码块会捕获异常,并创建一个包含异常信息的对象

//创建可抛出一个异常的函数
function checkNum($number){
    if($number>1){
        throw new Exception("Value must be 1 or below");
    }
}
//在 "try" 代码块中触发异常
try{
    checkNum(2);
}catch(Exception $e) { //捕获异常
    echo ‘File: ‘.$e->getFile().‘ line: ‘.$e->getLine().‘<br>‘;
    die(‘Message: ‘.$e->getMessage());
}

上面代码将获得类似这样一个错误:

File: E:\webdev\www\pdo\3.php line: 7
Message: Value must be 1 or below

代码解析:创建 checkNum() 函数。它检测数字是否大于 1。如果是,则抛出一个异常。在 "try" 代码块中调用 checkNum(),函数checkNum() 函数中的异常被抛出,"catch" 代码块接收到该异常,并创建一个包含异常信息的对象 ($e)。通过从这个 exception 对象输出来自该异常的错误消息

不过,为了遵循“每个 throw 必须对应一个 catch”的原则,可以设置一个顶层的异常处理器来处理漏掉的错误,见第7点


4、创建自定义的异常处理器

创建一个专门的类,当 PHP 中发生异常时,可调用其函数。该类必须是 exception 类的一个扩展。这个自定义的exception 类继承了 PHP 的 exception 类的所有属性,可向其添加自定义的函数。

class customException extends Exception{
    public function errorMessage(){
        return ‘Error on line ‘.$this->getLine().‘ in ‘.$this->getFile().‘: <b>‘.$this->getMessage().‘</b> is not a valid E-Mail address‘;
    }
}
$email = "someone@example...com";
try{
    //使用PHP过滤器验证邮箱有效性
    if(filter_var($email, FILTER_VALIDATE_EMAIL) === FALSE){  
        throw new customException($email);
    }
}catch (customException $e){
    echo $e->errorMessage();
}

这个新的类是旧的 exception 类的副本,外加 errorMessage() 函数。正因为它是旧类的副本,因此它从旧类继承了属性和方法,我们可以使用 exception 类的方法,比如 getLine() 、 getFile() 以及 getMessage()。

上面的代码抛出了一个异常,并通过一个自定义的 exception 类来捕获它:创建 errorMessage() 函数。如果 e-mail 地址不合法,则该函数返回一条错误消息


5、多个异常的捕获

可以为一段脚本使用多个异常,来检测多种情况。

可以使用多个 if..else 代码块,或一个switch 代码块,或者嵌套多个异常。这些异常能够使用不同的 exception 类,并返回不同的错误消息:

class customException extends Exception{
    public function errorMessage(){
        return = ‘Error on line ‘.$this->getLine().‘ in ‘.$this->getFile().‘: <b>‘.$this->getMessage().‘</b> is not a valid E-Mail address‘;
    }
}
$email = "someone@example.com";
try{
    if(filter_var($email, FILTER_VALIDATE_EMAIL) === FALSE){
        throw new customException($email);
    }
    //check for "example" in mail address
    if(strpos($email, "example") !== FALSE){
        throw new Exception("$email is an example e-mail");
    }
} catch (customException $e){
    echo $e->errorMessage();
}catch(Exception $e){
    echo $e->getMessage();
}

上面的代码测试了两种条件,如何任何条件不成立,则抛出一个异常:

执行 "try" 代码块,在第一个条件下,不会抛出异常。由于 e-mail 含有字符串 "example",第二个条件会触发异常。"catch" 代码块会捕获异常,并显示恰当的错误消息,如果没有捕获 customException,只捕获了 base exception,则在那里处理异常。


6、重新抛出异常

有时,当异常被抛出时,也许希望以不同于标准的方式对它进行处理。可以在一个 “catch” 代码块中再次抛出异常。脚本应该对用户隐藏系统错误。对程序员来说,系统错误也许很重要,但是用户对它们并不感兴趣。为了让用户更容易使用,可以再次抛出带有对用户比较友好的消息的异常:

class customException extends Exception{
    public function errorMessage(){
        return $this->getMessage().‘ is not a valid E-Mail address.‘;
    }
}
$email = "someone@example.com";
try{
    try{
        if(strpos($email, "example") !== FALSE){
            throw new Exception($email);
        }
    }catch(Exception $e){
        //re-throw exception
        throw new customException($email);
    }
}catch (customException $e){
    //display custom message
    echo $e->errorMessage();
}

上面的代码检测在邮件地址中是否含有字符串 "example"。如果有,则再次抛出异常:

把 $email 变量设置为一个有效的邮件地址,但含有字符串 "example"。"try" 代码块包含另一个 "try" 代码块,这样就可以再次抛出异常。由于 e-mail 包含字符串 "example",因此触发异常。"catch" 捕获到该异常,并重新抛出 "customException"。捕获到 "customException",并显示一条错误消息。

如果在其目前的 "try" 代码块中异常没有被捕获,则它将在更高层级上查找 catch 代码块。


7、设置顶层异常处理器

set_exception_handler() 函数可设置处理所有未捕获异常的用户定义函数

function myException($exception){
    echo "<b>Exception:</b> " , $exception->getMessage();
}
set_exception_handler(‘myException‘);
throw new Exception(‘Uncaught Exception occurred‘);

以上代码的输出应该类似这样:

Exception: Uncaught Exception occurred

在上面的代码中,不存在 "catch" 代码块,而是触发顶层的异常处理程序。应该使用此函数来捕获所有未被捕获的异常。
但是对于系统自动抛出的错误,会先经过set_error_handler处理并抛出异常才能被set_exception_handler处理

function myException($exception){
    echo "<b>Exception:</b> " , $exception->getMessage();
}
set_exception_handler(‘myException‘);
set_error_handler(function(){
    throw new Exception(‘错误!‘);
});
echo 10/0;  //触发被除数不能为0的警告

代码执行结果:Exception: 错误!


链接: https://www.fly63.com/article/detial/2057

前端JS 异常处理实践

大多时候(除:网络故障与请求被阻止外),使用fetch()返回的 Promise被标记为resolve,包括(接收到一个代表错误的 HTTP 状态码时,HTTP 响应的状态码是 404 或 500,但是,此时会将 resolve 的返回值的 ok 属性设置为 false

JavaScript错误处理权威指南

JavaScript 错误和一般处理 throw new Error(\'something went wrong\') 会在 JavaScript 中创建一个错误实例,并停止脚本的执行,除非你对错误做了一些处理。当你作为 JavaScript 开发者开启自己的职业生涯时,你自己很可能不会这样做

慎用try catch

ECMA-262第3版引入了try catch语句,作为JavaScript中处理异常的一种标准方式。基本的语法如下所示。但是在前端js代码中很少看到try catch语句,并不是所以代码都需要加try catch来作得不偿失的保险

前端开发中的Error以及异常捕获

在前端项目中,由于JavaScript本身是一个弱类型语言,加上浏览器环境的复杂性,网络问题等等,很容易发生错误。做好网页错误监控,不断优化代码,提高代码健壮性是一项很重要的工作

js中的异常处理

js中的异常处理语句有两个,一个是try……catch……,一个是throw。try……catch用于语法错误,错误有name和message两个属性。throw用于逻辑错误。对于逻辑错误,js是不会抛出异常的

关于try、catch、finally的执行顺序

try中没有抛出异常,则catch语句不执行,如果有finally语句,则接着执行finally语句,继而接着执行finally之后的语句;不管是否try...catch,finally都会被执行。当try...catch中有return的话,finally后会执行try...catch中的return

Laravel异常:捕获,处理和创建

很多开发者在开发过程中都会遇到异常,处理过程大同小异:捕获然后处理,事实上也确实是如此。只是从laravel自带的Exception入手,谈一谈怎样用一个更好的方式处理错误信息。

js中try、catch、finally的执行规则

首先一个常识就是,在浏览器执行JS脚本过程中,当出现脚本错误,并且你没有手动进行异常捕捉时,他会在浏览器下面出现黄色的叹号,这是正常的

Node中异常:exit code与 dockerfile

最近观察项目 CI 跑的情况如何时,会偶尔发现一两个镜像虽然构建成功但是容器跑不起来的情况。究其原因,是因为一个 exit code 的问题

从JavaScript到Python之异常

不少前端工程师看到这个标题可能会产生质问:我js用得好好的,能后端能APP,为什么还要学习Python?至少有下面两个理由:

点击更多...

内容以共享、参考、研究为目的,不存在任何商业目的。其版权属原作者所有,如有侵权或违规,请与小编联系!情况属实本人将予以删除!